# -*- coding: utf_8 -*-
from __future__ import with_statement
print "b29"
os.chdir("/Users/wstein/.sage/sage_notebook/worksheets/admin/116/cells/2")
sage.server.notebook.interact.SAGE_CELL_ID=2
_sage_const_40 = Integer(40); _sage_const_75 = Integer(75); _sage_const_1 = Integer(1); _sage_const_0 = Integer(0); _sage_const_1p0 = RealNumber('1.0'); _sage_const_208 = Integer(208); _sage_const_8 = Integer(8); _sage_const_0p0 = RealNumber('0.0')
import networkx as nx
from networkx.isomorph import graph_could_be_isomorphic as isomorphic
import random

def atlas6():
    """ Return the atlas of all connected graphs of 6 nodes or less.
        Attempt to check for isomorphisms and remove.
    """

    Atlas=nx.graph_atlas_g()[_sage_const_0 :_sage_const_208 ] # 208
    # remove isolated nodes, only connected graphs are left
    U=nx.Graph() # graph for union of all graphs in atlas
    for G in Atlas:
        zerodegree=[n for n in G if G.degree(n)==_sage_const_0 ]
        for n in zerodegree:
            G.delete_node(n)
        U=nx.disjoint_union(U,G)

    # list of graphs of all connected components
    C=nx.connected_component_subgraphs(U)

    UU=nx.Graph()
    # do quick isomorphic-like check, not a true isomorphism checker
    nlist=[] # list of nonisomorphic graphs
    for G in C:
        # check against all nonisomorphic graphs so far
        if not iso(G,nlist):
            nlist.append(G)
            UU=nx.disjoint_union(UU,G) # union the nonisomorphic graphs
    return UU

def iso(G1, glist):
    """Quick and dirty nonisomorphism checker used to check isomorphisms."""
    for G2 in glist:
        if isomorphic(G1,G2):
            return True
    return False



import networkx as nx

G=atlas6()

print "graph has %d nodes with %d edges"      %(nx.number_of_nodes(G),nx.number_of_edges(G))
print nx.number_connected_components(G),"connected components"


try:
    from networkx import graphviz_layout
except ImportError:
    raise ImportError("This example needs Graphviz and either PyGraphviz or Pydot")

import matplotlib.pyplot as plt
plt.figure(_sage_const_1 ,figsize=(_sage_const_8 ,_sage_const_8 ))
# layout graphs with positions using graphviz neato
pos=nx.graphviz_layout(G,prog="neato")
# color nodes the same in each connected subgraph
C=nx.connected_component_subgraphs(G)
for g in C:
    c=[random.random()]*nx.number_of_nodes(g) # random color...
    nx.draw(g,
         pos,
         node_size=_sage_const_40 ,
         node_color=c,
         vmin=_sage_const_0p0 ,
         vmax=_sage_const_1p0 ,
         with_labels=False
         )
exec compile(ur'plt.savefig("atlas.png",dpi=_sage_const_75 )' + '\n', '', 'single')

print "e29"
